=== modified file 'ivle/dispatch/__init__.py'
--- ivle/dispatch/__init__.py	2009-12-02 02:20:57 +0000
+++ ivle/dispatch/__init__.py	2009-12-02 03:38:07 +0000
@@ -66,7 +66,11 @@
         """Check that the user has any permission at all over the object."""
         if (hasattr(obj, 'get_permissions') and
             len(obj.get_permissions(self.root.user)) == 0):
-            raise Unauthorized()
+            # Indicate the forbidden object if this is an admin.
+            if self.root.user and self.root.user.admin:
+                raise Unauthorized('Unauthorized: %s' % obj)
+            else:
+                raise Unauthorized()
 
 
 def generate_publisher(view_plugins, root):
@@ -140,7 +144,11 @@
             # Check that the request (mainly the user) is permitted to access
             # the view.
             if not view.authorize(req):
-                raise Unauthorized()
+                # Indicate the forbidden object if this is an admin.
+                if req.user and req.user.admin:
+                    raise Unauthorized('Unauthorized: %s' % view)
+                else:
+                    raise Unauthorized()
             # Render the output
             view.render(req)
         except HTTPError, e:

=== modified file 'ivle/webapp/base/xhtmlunauthorized.html'
--- ivle/webapp/base/xhtmlunauthorized.html	2009-02-25 03:04:08 +0000
+++ ivle/webapp/base/xhtmlunauthorized.html	2009-12-02 03:38:07 +0000
@@ -6,7 +6,7 @@
   <body>
     <h1>Unauthorized</h1>
     <div id="ivle_padding">
-      <p>You are not allowed to view this part of IVLE.</p>
+      <p py:if="exception.message">${exception.message}</p>
     </div>
   </body>
 </html>

